diff --git a/pgadmin/frm/frmQuery.cpp b/pgadmin/frm/frmQuery.cpp
index 1ceeed3..1a460f3 100644
--- a/pgadmin/frm/frmQuery.cpp
+++ b/pgadmin/frm/frmQuery.cpp
@@ -1875,6 +1875,11 @@ void frmQuery::OnCancel(wxCommandEvent& event)
         sqlResult->Abort();
     else if (pgScript->IsRunning())
         pgScript->Terminate();
+
+    QueryExecInfo *qi = (QueryExecInfo *)event.GetClientData();
+	if (qi)
+		delete qi;
+
     aborted=true;
 }
 
@@ -2447,6 +2452,7 @@ void frmQuery::OnQueryComplete(wxCommandEvent &ev)
     }
 
     completeQuery(done, qi->explain, qi->verbose);
+	delete qi;
 }
 
 
